--
-- Copyright (C) 2012-2016 Snail <https://github.com/snail23/snailui/>
--
-- This program is free software; you can redistribute it and/or modify it
-- under the terms of the GNU General Public License as published by the
-- Free Software Foundation; either version 2 of the License, or (at your
-- option) any later version.
--
-- This program is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-- FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
-- more details.
--
-- You should have received a copy of the GNU General Public License along
-- with this program. If not, see <http://www.gnu.org/licenses/>.
--

local ITEM_QUALITY_UNCOMMON	= 2
local ITEM_QUALITY_RARE		= 3

function HandleAutoGreed()
	local AutoGreed = CreateFrame("Frame", nil, UIParent)

	AutoGreed:RegisterEvent("CONFIRM_LOOT_ROLL")
	AutoGreed:RegisterEvent("START_LOOT_ROLL")

	AutoGreed:SetScript("OnEvent",
		function(Self, Event, Id, ...)
			if Id then
				local _, Name, _, Quality, _, Needable = GetLootRollItemInfo(Id)
				local Usable = IsEquippableItem(Name) or IsUsableItem(Name)

				if Event == "CONFIRM_LOOT_ROLL" then
					ConfirmLootRoll(Id, ...)
				elseif (Quality == ITEM_QUALITY_UNCOMMON) or ((Quality == ITEM_QUALITY_RARE) and ((not Needable) or (not Usable))) then
					RollOnLoot(Id, 2)
				end
			end
		end
	)
end
