--
-- Copyright (C) 2012-2016 Snail <https://github.com/snail23/snailui/>
--
-- This program is free software; you can redistribute it and/or modify it
-- under the terms of the GNU General Public License as published by the
-- Free Software Foundation; either version 2 of the License, or (at your
-- option) any later version.
--
-- This program is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-- FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
-- more details.
--
-- You should have received a copy of the GNU General Public License along
-- with this program. If not, see <http://www.gnu.org/licenses/>.
--

function HandleXPBar(Self)
	if GetConfiguration().XPBar and (Self.Frame == "Player") then
		local Class = select(2, UnitClass(Self.Frame))

		Self.Experience = CreateFrame('StatusBar', nil, Self)
		Self.Experience:SetPoint(GetConfiguration().XPBar.Anchor, UIParent, GetConfiguration().XPBar.X, GetConfiguration().XPBar.Y)
		Self.Experience:SetSize(GetConfiguration().XPBar.Width - 6, GetConfiguration().XPBar.Height - 6)
		Self.Experience:SetStatusBarTexture(Configuration.Texture)
		Self.Experience:SetStatusBarColor(RAID_CLASS_COLORS[Class].r, RAID_CLASS_COLORS[Class].g, RAID_CLASS_COLORS[Class].b)
		Self.Experience:SetScript("OnShow",
			function(Self)
				if not ExtraButton.Shown then
					Self:Hide()
				end
			end
		)

		SmoothBar(Self, Self.Experience)

		Self.Experience.BackgroundBottom = Self.Experience:CreateTexture(nil, "LOW")
		Self.Experience.BackgroundBottom:SetPoint("BOTTOM", 0, -2)
		Self.Experience.BackgroundBottom:SetSize(GetConfiguration().XPBar.Width - 2, 1)
		Self.Experience.BackgroundBottom:SetTexture(RAID_CLASS_COLORS[Class].r, RAID_CLASS_COLORS[Class].g, RAID_CLASS_COLORS[Class].b)

		Self.Experience.BackgroundLeft = Self.Experience:CreateTexture(nil, "LOW")
		Self.Experience.BackgroundLeft:SetPoint("LEFT", -2, 0)
		Self.Experience.BackgroundLeft:SetSize(1, GetConfiguration().XPBar.Height - 4)
		Self.Experience.BackgroundLeft:SetTexture(RAID_CLASS_COLORS[Class].r, RAID_CLASS_COLORS[Class].g, RAID_CLASS_COLORS[Class].b)

		Self.Experience.BackgroundRight = Self.Experience:CreateTexture(nil, "LOW")
		Self.Experience.BackgroundRight:SetPoint("RIGHT", 2, 0)
		Self.Experience.BackgroundRight:SetSize(1, GetConfiguration().XPBar.Height - 4)
		Self.Experience.BackgroundRight:SetTexture(RAID_CLASS_COLORS[Class].r, RAID_CLASS_COLORS[Class].g, RAID_CLASS_COLORS[Class].b)

		Self.Experience.BackgroundTop = Self.Experience:CreateTexture(nil, "LOW")
		Self.Experience.BackgroundTop:SetPoint("TOP", 0, 2)
		Self.Experience.BackgroundTop:SetSize(GetConfiguration().XPBar.Width - 2, 1)
		Self.Experience.BackgroundTop:SetTexture(RAID_CLASS_COLORS[Class].r, RAID_CLASS_COLORS[Class].g, RAID_CLASS_COLORS[Class].b)

		Self.Experience.Border = Self.Experience:CreateTexture(nil, "BACKGROUND")
		Self.Experience.Border:SetPoint("CENTER")
		Self.Experience.Border:SetSize(GetConfiguration().XPBar.Width - 4, GetConfiguration().XPBar.Height - 4)
		Self.Experience.Border:SetTexture(0, 0, 0)

		Self.Experience.BorderBottom = Self.Experience:CreateTexture(nil, "BACKGROUND")
		Self.Experience.BorderBottom:SetPoint("BOTTOM", 0, -3)
		Self.Experience.BorderBottom:SetSize(GetConfiguration().XPBar.Width, 1)
		Self.Experience.BorderBottom:SetTexture(0, 0, 0)

		Self.Experience.BorderLeft = Self.Experience:CreateTexture(nil, "BACKGROUND")
		Self.Experience.BorderLeft:SetPoint("LEFT", -3, 0)
		Self.Experience.BorderLeft:SetSize(1, GetConfiguration().XPBar.Height)
		Self.Experience.BorderLeft:SetTexture(0, 0, 0)

		Self.Experience.BorderRight = Self.Experience:CreateTexture(nil, "BACKGROUND")
		Self.Experience.BorderRight:SetPoint("RIGHT", 3, 0)
		Self.Experience.BorderRight:SetSize(1, GetConfiguration().XPBar.Height)
		Self.Experience.BorderRight:SetTexture(0, 0, 0)

		Self.Experience.Rested = CreateFrame('StatusBar', nil, Self.Experience)
		Self.Experience.Rested:SetAllPoints(Self.Experience)
		Self.Experience.Rested:SetStatusBarColor(RAID_CLASS_COLORS[Class].r * Configuration.TextColorPercentage, RAID_CLASS_COLORS[Class].g * Configuration.TextColorPercentage, RAID_CLASS_COLORS[Class].b * Configuration.TextColorPercentage)
	
		SmoothBar(Self.Experience, Self.Experience.Rested)
	end
end
