--
-- Copyright (C) 2012-2016 Snail <https://github.com/snail23/snailui/>
--
-- This program is free software; you can redistribute it and/or modify it
-- under the terms of the GNU General Public License as published by the
-- Free Software Foundation; either version 2 of the License, or (at your
-- option) any later version.
--
-- This program is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-- FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
-- more details.
--
-- You should have received a copy of the GNU General Public License along
-- with this program. If not, see <http://www.gnu.org/licenses/>.
--

local Version = "1.5.0"
local BlacklistedAddons =
{
	"oUF",
	"oUF_Experience",
	"oUF_FloatingCombatFeedback",
	"oUF_Smooth",
	"oUF_SpellRange",
	"oUF_WarlockSpecBars"
}

for I = 1, #BlacklistedAddons do
	if IsAddOnLoaded(BlacklistedAddons[I]) then
		DisableAddOn(BlacklistedAddons[I])
	end
end

oUF:RegisterStyle("SnailUI",
	function(Self, Unit)
		Unit = Unit:gsub("(.)", string.upper, 1)

		if GetConfiguration()[Unit] then
			Self.Frame = Unit
			
			HandleBurningEmbersBar(Self)
			HandleCastingBar(Self)
			HandleClassBar(Self, "Chi")
			HandleClassBar(Self, "HolyPower")
			HandleClassBar(Self, "ShadowOrbs")
			HandleClassBar(Self, "SoulShards")
			HandleColors(Self)
			HandleComboPointsBar(Self)
			HandleDebuffIndicators(Self)
			HandleDemonicFuryBar(Self)
			HandleEclipseBar(Self)
			HandleHealingIndicators(Self)
			HandleHealthBar(Self)
			HandlePortrait(Self)
			HandlePowerBar(Self)
			HandleRunesBar(Self)
			HandleSCT(Self)
			HandleSpellRange(Self)
			HandleUnit(Self)
			HandleXPBar(Self)
		end
	end
)

oUF:Factory(
	function(Self)
		if GetConfiguration().Initialize then
			GetConfiguration():Initialize()
		end

		HandleActionBars()
		HandleAutoGreed()
		HandleAutoRepair()
		HandleBag()
		HandleBank()
		HandleBattlegroundAutoRelease()
		HandleBattlegroundScore()
		HandleBlizzardFrames()
		HandleBlizzardTrackers()
		HandleBuffs()
		HandleChat()
		HandleConsoleVariables()
		HandleExtraButton()
		HandleFocus(Self)
		HandleFocusTarget(Self)
		HandleGarbageCollector()
		HandleMeter()
		HandleMinimap()
		HandleNameplates()
		HandlePet(Self)
		HandlePlayer(Self)
		HandleRaid(Self)
		HandleTarget(Self)
		HandleTargetTarget(Self)
		HandleTimers()
		HandleTooltips()
		HandleOptions(Version)

		Self:SetActiveStyle("SnailUI")

		if GetConfiguration().XPBar then
			oUF_SnailUIPlayer.Experience:Hide()
		end
	end
)
